var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ModelConverter } from "yuni-chanz-react";
import DdbUtils from "../utils/DdbUtils";
var AwsModelConverter = /** @class */ (function (_super) {
    __extends(AwsModelConverter, _super);
    function AwsModelConverter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Encodes the specified number value to a DDB attribute value.
     */
    AwsModelConverter.prototype.encodeNumber = function (value) {
        return DdbUtils.getNumberAV(value);
    };
    /**
     * Encodes the specified string value to a DDB attribute value.
     */
    AwsModelConverter.prototype.encodeString = function (value) {
        return DdbUtils.getStringAV(value);
    };
    /**
     * Encodes the specified bool value to a DDB attribute value.
     */
    AwsModelConverter.prototype.encodeBool = function (value) {
        return DdbUtils.getBoolAV(value);
    };
    /**
     * Encodes the specified string array value to a DDB attribute value.
     */
    AwsModelConverter.prototype.encodeStringArray = function (value) {
        return DdbUtils.getStringArrayAV(value);
    };
    /**
     * Encodes the specified number array value to a DDB attribute value.
     */
    AwsModelConverter.prototype.encodeNumberArray = function (value) {
        return DdbUtils.getNumberArrayAV(value);
    };
    /**
     * Encodes the specified date instance to a storable type.
     */
    AwsModelConverter.prototype.encodeDate = function (value) {
        return DdbUtils.getDateAV(value);
    };
    /**
     * Decodes the specified raw value to an int.
     */
    AwsModelConverter.prototype.decodeInt = function (value) {
        return _super.prototype.decodeInt.call(this, value.N);
    };
    /**
     * Decodes the specified raw value to a float.
     */
    AwsModelConverter.prototype.decodeFloat = function (value) {
        return _super.prototype.decodeFloat.call(this, value.N);
    };
    /**
     * Decodes the specified raw value to a string.
     */
    AwsModelConverter.prototype.decodeString = function (value) {
        return _super.prototype.decodeString.call(this, value.S);
    };
    /**
     * Decodes the specified raw value to a bool.
     */
    AwsModelConverter.prototype.decodeBool = function (value) {
        return _super.prototype.decodeBool.call(this, value.BOOL);
    };
    /**
     * Decodes the specified raw value to a string array.
     */
    AwsModelConverter.prototype.decodeStringArray = function (value) {
        var _a;
        return (_a = value.SS) !== null && _a !== void 0 ? _a : null;
    };
    /**
     * Decodes the specified raw value to an integer array.
     */
    AwsModelConverter.prototype.decodeIntArray = function (value, radix) {
        if (radix === void 0) { radix = 10; }
        if (value.NS === undefined) {
            return null;
        }
        var intArray = [];
        for (var _i = 0, _a = value.NS; _i < _a.length; _i++) {
            var v = _a[_i];
            var val = _super.prototype.decodeInt.call(this, v, radix);
            if (val === null) {
                return null;
            }
            intArray.push(val);
        }
        return intArray;
    };
    /**
     * Decodes the specified raw value to a float array.
     */
    AwsModelConverter.prototype.decodeFloatArray = function (value) {
        if (value.NS === undefined) {
            return null;
        }
        var intArray = [];
        for (var _i = 0, _a = value.NS; _i < _a.length; _i++) {
            var v = _a[_i];
            var val = _super.prototype.decodeFloat.call(this, v);
            if (val === null) {
                return null;
            }
            intArray.push(val);
        }
        return intArray;
    };
    /**
     * Decodes the specified raw value to a Date instance.
     */
    AwsModelConverter.prototype.decodeDate = function (value) {
        return _super.prototype.decodeDate.call(this, value.S);
    };
    return AwsModelConverter;
}(ModelConverter));
export default AwsModelConverter;
