var DdbUtils = /** @class */ (function () {
    function DdbUtils() {
    }
    /**
     * Returns the specified number as DDB attribute value.
     */
    DdbUtils.prototype.getNumberAV = function (value) {
        return {
            N: value.toString(),
        };
    };
    /**
     * Returns the specified string as DDB attribute value.
     */
    DdbUtils.prototype.getStringAV = function (value) {
        return {
            S: value,
        };
    };
    /**
     * Returns the specified bool as DDB attribute value.
     */
    DdbUtils.prototype.getBoolAV = function (value) {
        return {
            BOOL: value,
        };
    };
    /**
     * Returns the specified date as DDB attribute value.
     */
    DdbUtils.prototype.getDateAV = function (value) {
        return {
            S: value.toISOString(),
        };
    };
    /**
     * Returns the specified string array as DDB attribute value.
     */
    DdbUtils.prototype.getStringArrayAV = function (value) {
        return {
            SS: value,
        };
    };
    /**
     * Returns the specified numberarray as DDB attribute value.
     */
    DdbUtils.prototype.getNumberArrayAV = function (value) {
        return {
            NS: value.map(function (v) { return v.toString(); }),
        };
    };
    return DdbUtils;
}());
export default new DdbUtils();
